"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
exports.validateCommandArguments = (argv) => {
    if (Object.prototype.hasOwnProperty.call(argv, "yes") && typeof argv.yes !== "boolean") {
        throw new Error(chalk_1.default `The {bold --yes} argument can only be set as a flag.`);
    }
    if (Object.prototype.hasOwnProperty.call(argv, "new")) {
        if (typeof argv.new !== "string") {
            throw new Error(chalk_1.default `The {bold --new} argument can only be a string.`);
        }
        if (!argv.new.trim()) {
            throw new Error(chalk_1.default `The {bold --new} argument value cannot be blank.`);
        }
    }
};
exports.validateFramerToken = () => {
    if (!process.env.FRAMER_TOKEN) {
        throw new Error(chalk_1.default `Missing {bold FRAMER_TOKEN} environment variable.\nRun the {bold {underline authenticate}} command to obtain your {bold FRAMER_TOKEN}.`);
    }
};
exports.validatePublishScope = (isPrivate, project) => __awaiter(this, void 0, void 0, function* () {
    if (isPrivate && !(yield project.canBePublishedPrivately)) {
        throw new Error(chalk_1.default `Package cannot be published privately./nPlease re-run this command with the {bold --public} flag.`);
    }
});
exports.validateCanFetchPackageData = (newName, project) => {
    if (!project.packageName && !project.packageFramerName && !newName) {
        throw new Error(chalk_1.default `Cannot fetch package info because of missing information.\nPlease re-run this command with a {bold display name} using the {bold --new} argument.`);
    }
};
